import Cocoa
import FlutterMacOS

public class AssistivePlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "plugins.flutter.io/assistive_plugin", binaryMessenger: registrar.messenger)
    let instance = AssistivePlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    switch call.method {
    case "getPlatformVersion":
      result("macOS " + ProcessInfo.processInfo.operatingSystemVersionString)
    case "checkForAssibility":
      result(checkForAssibilityPermission())
    default:
      result(FlutterMethodNotImplemented)
    }
  }
}

private func checkForAssibilityPermission() -> Bool {
    let allow = AXIsProcessTrusted();
    if(allow){
    return true;
    }else{
        NSURL *URL = [NSURL URLWithString:@"x-apple.systempreferences:com.apple.preference.security?Privacy_Accessibility"];
        [[NSWorkspace sharedWorkspace] openURL:URL];
    }
    return false;
    /* NSString* prefPage = @"x-apple.systempreferences:com.apple.preference.security?Privacy_Accessibility";
    [[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:prefPage]]; */
}